package SAE.ApiREST.WebService.service;
import SAE.ApiREST.WebService.model.Collect;
import SAE.ApiREST.WebService.model.Teacher;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

import SAE.ApiREST.WebService.model.Article;
import org.springframework.stereotype.Service;
import SAE.ApiREST.WebService.model.Collect;

@Service
public class StubCollectionService implements ICollectionService {

    @Override
    public List<Collect> getAllCollections() {
        List<Collect> collections = new ArrayList<>();

        collections.add(new Collect("collect1",  new Teacher(1, "12-01-2023", "aline.alipres@gmail.com", "MsGarconManque")));

        Collect collection2 = new Collect("collect2",  new Teacher(1, "12-01-2023", "aline.alipres@gmail.com", "MsGarconManque"));
        collection2.addArticle(new Article("toi","azezeaea", LocalDate.now().minusMonths(1),LocalDate.now().minusMonths(2),true,1));
        collections.add(collection2);

        Collect collection3 = new Collect("collect3",  new Teacher(1, "12-01-2023", "aline.alipres@gmail.com", "MsGarconManque"));
        collection3.addArticle(new Article("toi","azezeaea",LocalDate.now().minusMonths(1),LocalDate.now().minusMonths(2),true,1));
        collection3.addArticle(new Article("toi","azezeaea",LocalDate.now().minusMonths(1),LocalDate.now().minusMonths(2),true,1));
        collections.add(collection3);

        return collections;
    }

    // region Collection

    // region GET
    @Override
    public Collect getCollectionById(long isbn){
        List<Collect> collections = getAllCollections();
        for(Collect collection : collections){
            if(collection.getId() == isbn) {
                return collection;
            }
        }
        return null;
    }

    @Override
    public List<Collect> getAllCollectionsByName(String name){
        List<Collect> collections = getAllCollections();
        ArrayList<Collect> repCollections = new ArrayList<Collect>();
        for(Collect collection : collections){
            if(Objects.equals(collection.getName(), name)) {
                repCollections.add(collection);
            }
        }
        return repCollections;
    }
    // endregion

    // region DELETE
    @Override
    public void deleteColletionById(long isbn){
        List<Collect> collections = getAllCollections();
        Collect collection = getCollectionById(isbn);
        collections.remove(collection);
    }

    @Override
    public void deleteColletionByName(String name){
        List<Collect> collections = getAllCollections();
        List<Collect> collectionsByName = getAllCollectionsByName(name);
        collections.remove(collectionsByName.get(0));
    }

    @Override
    public void deleteAllColletionByName(String name){
        List<Collect> collections = getAllCollections();
        List<Collect> collectionsByName = getAllCollectionsByName(name);
        collections.removeAll(collectionsByName);
    }

    @Override
    public void addCollection(Collect collection) {
        List<Collect> collections = getAllCollections();
            collections.add(collection);
    }
    // endregion

    // region PUT
    @Override
    public void addCollections(List<Collect> collections){
        List<Collect> collectionsStub = getAllCollections();
        collections.addAll(collectionsStub);
    }
    // endregion

    // region POST
    @Override
    public void modifyCollectionName(Collect collection, String name){
        collection.setName(name);
    }

    @Override
    public void modifyCollectionNameById(long isbn, String name){
        Collect collection = getCollectionById(isbn);
        modifyCollectionName(collection,name);
    }
    // endregion
    // endregion

    // region Article
    @Override
    public List<Article> getAllArticles(Collect collect){
        return collect.getAllArticles();
    }
    @Override
    public void addArticle(Collect collect, Article article){
        collect.addArticle(article);
    }
    @Override
    public void deleteArticle(Collect collect, Article article){
        collect.removeArticle(article);
    }
    //  endregion
}